import java.awt.Graphics;

/**
 * Animatable
 * 
 * I model an object that can be animated
 * 
 * If you want to be an Animatable type,
 * please implement the methods below. 
 *
 */

public interface Animatable {

	/** Move forward inside frame "f" ("f" may dictate a reflection, etc) */
	public void forwardIn(Frame f);
	
	/** Set the direction this object is pointing (moving) */
	public void direction(int direction);
	
	/** Draw this drawable object on graphics "g" */
	public void drawOn(Graphics g);	
	
}
