import java.awt.Color;
import java.util.Random;

/** Models an abstract grahics element */
abstract public class GraphicsElement {
	
	//----------------------------------------------------------------
	//Ivars
	
	//Cosmetic/display graphic properties
	private Color color;
	//Line thickness (roughly equivalent to 1/72 of an inch)	
	private int thickness;
	
	//----------------------------------------------------------------
	//Accessors (Getters & Setters)
	
	public Color getColor() {
		return color;
	}

	public int getThickness() {
		return thickness;
	}	
		
	public void setColor(Color color) {
		this.color = color;
	}	
	
	public void setThickness(int aThickness) {
		this.thickness = aThickness;
	}	
	
	//----------------------------------------------------------------
	//Constructors	
	
	public GraphicsElement() {
		this.setColor(null);
		this.setThickness(0);
	}
	
	//----------------------------------------------------------------
	//Instance Methods
	
	public void setRandomThickness() {
		this.thickness = (new Random()).nextInt(1, 50);
	}	
	
	public void setRandomColor() {
		this.color = GraphicsToolbox.randomColor();
	}
	
	public void randomizeDisplayProperties() {
		this.setRandomThickness();
		this.setRandomColor();
	}	
	
}
