import java.awt.Graphics;

/** Point
 * models a two-dimensional point (x, y)
 * A position in 2D space */
public class Point {
	
	//----------------------------------------------------------------
	//Ivars
	
	private int x;
	private int y;

	//----------------------------------------------------------------
	//Accessors (Getters & Getters)
	
	public int getX() {
		return x;
	}
	
	public int getY() {
		return y;
	}
	
	public void setX(int x) {
		this.x = x;
	}	
	
	public void setY(int y) {
		this.y = y;
	}

	//----------------------------------------------------------------
	//Constructors
	
	public Point() {
		this(0, 0);	//default point is origin (0, 0)
	}

	public Point(int x, int y) {
		super();
		this.x = x;
		this.y = y;
	}

	//----------------------------------------------------------------
	//Instance Methods

	/** Draw line to "end" point on graphics "g" */
	public void drawToOn(Point end, Graphics g) {
		g.drawLine(this.getX(), this.getY(), end.getX(), end.getY());
	}

	@Override
	public String toString() {
		return "Point [x=" + x + ", y=" + y + "]";
	}

	/** Moves this point by vector */
	public void moveBy(Vector vector) {
		Vector rounded = vector.rounded();
		this.x += rounded.getX();
		this.y += rounded.getY();
	}

	/** Returns new point, moved by (distance, distance) */ 
	public Point minus(int distance) {
		return new Point(this.x + distance, this.y + distance);
	}	
	
	
	
}
