
/** Vector
 * Models a direction (x, y) in 2D space.
*/
public class Vector {
	
	//----------------------------------------------------------------
	//Ivars
	
	private double x;
	private double y;

	//----------------------------------------------------------------
	//Accessors (Getters & Getters)
	
	public double getX() {
		return x;
	}
	
	public double getY() {
		return y;
	}
	
	public void setX(double x) {
		this.x = x;
	}	
	
	public void setY(double y) {
		this.y = y;
	}

	//----------------------------------------------------------------
	//Constructors
	
	public Vector() {
		this(0, 0);	//default point is origin (0, 0)
	}

	public Vector(double x, double y) {
		super();
		this.x = x;
		this.y = y;
	}

	//----------------------------------------------------------------
	//Instance Methods

	@Override
	public String toString() {
		return "Vector [x=" + x + ", y=" + y + "]";
	}
	
	/** Returns this vector as an angle (radians) */
	public double toAngle() {
		if (this.x == 0) return 0.0;
		return Math.asin(this.y / this.x);
	}

	/** Returns new vector with x and y multiplied by paran "distance" */	
	public Vector multiply(double distance) {
		return new Vector(this.x * distance, this.y * distance);
	}	
	
	/** Returns new vector with x and y rounded to nearest integers */
	public Vector rounded() {
		return new Vector(Math.round(this.x), Math.round(this.y));
	}
	
	
}
