import java.awt.BasicStroke;
import java.awt.Graphics;
import java.awt.Graphics2D;

/** models a two-dimensional point (x, y) */
public class Line extends GraphicsElement implements Drawable {
	
	//----------------------------------------------------------------
	//Ivars
	
	//Geometric properties
	private Point start;
	private Point end;
	
	//----------------------------------------------------------------
	//Constructors
	
	/** Construct line from point (x1, y1) to point (x2, y2) */
	public Line(int x1, int y1, int x2, int y2) {
		this(new Point(x1, y1), new Point(x2, y2));
	}

	/** Construct line from point "p1" to point "p2" */
	public Line(Point p1, Point p2) {
		super();
		this.start = p1;
		this.end = p2;
	}	

	//----------------------------------------------------------------
	//Instance Methods	
	

	//----------------------------------------------------------------
	//Drawable type overrides
	
	@Override
	public void drawOn(Graphics g) {
		Graphics2D g2 = (Graphics2D) g;		
		if (this.getColor() != null)
			g2.setColor(this.getColor());
		if (this.getThickness() > 0)
			g2.setStroke(new BasicStroke(this.getThickness()));
		this.start.drawToOn(this.end, g2);
	}
		
}
