import java.awt.Graphics;

/** models a two-dimensional point (x, y) */
public class Point {
	
	//----------------------------------------------------------------
	//Ivars
	
	private int x;
	private int y;

	//----------------------------------------------------------------
	//Accessors (Getters & Getters)
	
	public int getX() {
		return x;
	}
	
	public int getY() {
		return y;
	}
	
	public void setX(int x) {
		this.x = x;
	}	
	
	public void setY(int y) {
		this.y = y;
	}

	//----------------------------------------------------------------
	//Constructors
	
	public Point() {
		this(0, 0);	//default point is origin (0, 0)
	}

	public Point(int x, int y) {
		super();
		this.x = x;
		this.y = y;
	}

	//----------------------------------------------------------------
	//Instance Methods

	/** Draw line to "end" point on graphics "g" */
	public void drawToOn(Point end, Graphics g) {
		g.drawLine(this.getX(), this.getY(), end.getX(), end.getY());
	}	
	
}
